config/routes.rb
Rails.application.routes.draw do
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  get 'home/index'
  get 'challenges', to: 'challenges#index'
  get 'challenges/:id', to: 'challenges#show', as: :challenge
  get 'dashboard', to: 'dashboards#index'
  get 'profile', to: 'users#show', as: :profile

  post 'challenges/:id/join', to: 'challenges#join', as: :join_challenge

  resources :challenges do
    resources :feedbacks, only: [:create]
  end

  devise_for :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
  root to: 'home#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/badge.rb
class Badge < ApplicationRecord
    has_many :user_badges
  
    validates :name, presence: true
  end

app/models/challenge.rb
class Challenge < ApplicationRecord
    has_many :user_challenges
    has_many :leaderboards
    has_many :feedbacks
  
    validates :name, presence: true
  end
  

app/models/feedback.rb
class Feedback < ApplicationRecord
  belongs_to :user
  belongs_to :challenge

  validates :message, presence: true
end

app/models/leaderboard.rb
class Leaderboard < ApplicationRecord
  belongs_to :challenge
  belongs_to :user

  validates :rank, numericality: { only_integer: true, greater_than_or_equal_to: 1 }
end

app/models/notification.rb
class Notification < ApplicationRecord
  belongs_to :user

  validates :message, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  has_many :user_challenges
  has_many :leaderboards
  has_many :user_badges
  has_many :notifications
  has_many :feedbacks
  has_one_attached :profile_picture

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  validates_each :email do |record, attr, value|
    unless value.downcase.end_with?('@ait.ac.th')
      record.errors.add(attr, 'must be an AIT email')
    end
  end

  attribute :admin, :boolean, default: false
end

app/models/user_badge.rb
class UserBadge < ApplicationRecord
  belongs_to :user
  belongs_to :badge
end

app/models/user_challenge.rb
class UserChallenge < ApplicationRecord
  belongs_to :user
  belongs_to :challenge

  validates :points_earned, numericality: { greater_than_or_equal_to: 0 }

  # Method to update points
  def add_points(points)
    update(points_earned: points_earned + points)
  end
end

app/controllers/badges_controller.rb
class BadgesController < ApplicationController
    before_action :authenticate_user!
  
    def index
      @badges = Badge.all
    end
  
  end
  

app/controllers/dashboards_controller.rb
class DashboardsController < ApplicationController
    before_action :authenticate_user!
  
    def index
      @user_challenges = current_user.user_challenges.joins(:challenge).where('challenges.end_date > ?', DateTime.now)
      @leaderboard_positions = Leaderboard.where(user: current_user).includes(:challenge)
      @notifications = current_user.notifications
    end    
end
  

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @challenges = Challenge.where("end_date > ?", DateTime.now)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
    before_action :authenticate_user!
  
    def show
      @user = current_user
    end
  end
  

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/badges_helper.rb
module BadgesHelper
end

app/helpers/challenges_helper.rb
module ChallengesHelper
end

app/helpers/dashboards_helper.rb
module DashboardsHelper
end

app/helpers/feedbacks_helper.rb
module FeedbacksHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/leaderboards_helper.rb
module LeaderboardsHelper
end

app/helpers/notifications_helper.rb
module NotificationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/dashboards/index.html.erb
<h1>User Dashboard</h1>

<h2>Your Challenges</h2>
<% if @user_challenges.any? %>
  <% @user_challenges.each do |user_challenge| %>
    <div>
      <h3><%= user_challenge.challenge.name %></h3>
      <p>Progress: <%= user_challenge.points_earned %> points</p>
    </div>
  <% end %>
<% else %>
  <p>You are not currently participating in any challenges.</p>
<% end %>

<h2>Leaderboard Positions</h2>
<% if @leaderboard_positions.any? %>
  <% @leaderboard_positions.each do |position| %>
    <div>
      <h3><%= position.challenge.name %></h3>
      <p>Your Rank: <%= position.rank %></p>
    </div>
  <% end %>
<% else %>
  <p>You are not currently ranked in any leaderboards.</p>
<% end %>

<h2>Notifications</h2>
<% if @notifications.any? %>
  <% @notifications.each do |notification| %>
    <p><%= notification.message %></p>
  <% end %>
<% else %>
  <p>There are no new notifications.</p>
<% end %>

<%= link_to 'Back to Home Page', root_path, class: 'btn btn-primary' %>
<br>
<%= link_to 'View Profile', profile_path, class: 'btn btn-secondary' %>